// ConfMsg.cpp: implementation of the CConfMsg class.
//
//////////////////////////////////////////////////////////////////////

#include "ConfMsg.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CConfMsg::CConfMsg()
{
	memset(&m_cCorpID, 0, sizeof(m_cCorpID));
	memset(&m_cSpNum, 0, sizeof(m_cSpNum));

	memset(&m_cLUserName, 0, sizeof(m_cLUserName));
	memset(&m_cLUserPwd, 0, sizeof(m_cLUserPwd));

	memset(&m_cRUserName, 0, sizeof(m_cRUserName));
	memset(&m_cRUserPwd, 0, sizeof(m_cRUserPwd));

	memset(&m_cSourceID, 0, sizeof(m_cSourceID));
	memset(&m_cClientIP, 0, sizeof(m_cClientIP));

	memset(&m_cServerIP, 0, sizeof(m_cServerIP));
	
	m_nLocalPort = 5089;
	m_nServerPort = 5088;

	//db info
	memset(&m_cDbAddr, 0, sizeof(m_cDbAddr));
	memset(&m_cDbSrv, 0, sizeof(m_cDbSrv));
	memset(&m_cDbUser, 0, sizeof(m_cDbUser));
	memset(&m_cDbPass, 0, sizeof(m_cDbPass));
	m_nDbPort = 0;

	m_bInitConf = false;
}

CConfMsg::~CConfMsg()
{

}

void  CConfMsg::GetValByName(const char *pName, char *pBuf, char *pVal)
{
	if ((pName == NULL) || (pBuf == NULL) || (pVal == NULL))
		return;
	
	char *pTmp = NULL;
	if ((pTmp = strstr(pBuf, pName)) == NULL)
		return;
	
	char *p = strstr(pTmp, "=");
	if (p == NULL)
		return;
	p++;
	while ((*p!=' ') && (*p!='\t') && (*p!='\n') && (*p!='\r'))
	{
		*pVal++ = *p++;
	}
	return;
}

bool CConfMsg::initConfig(char *pFile)
{
	int nHand = 0;
	int nLen = 0;
	char cBuf[1024] = "";
	if (pFile != NULL)
	{
		if ((nHand = open(pFile, O_RDONLY)) == END_FAILED)
			return false;
	}
	else
	{
		if ((nHand = open("./sgipc.ini", O_RDONLY)) == END_FAILED)
		{
			if ((nHand = open("../config/sgipc.ini", O_RDONLY)) == END_FAILED)
				return false;
		}
	}	
	
	//lseek(nHand, 0L, SEEK_SET);
	nLen = lseek(nHand, 0L, SEEK_END);
	lseek(nHand, 0L, SEEK_SET);
	int nReadLen = read(nHand, &cBuf, nLen);
	if (nReadLen <= 0)
	{
		close(nHand);
		return false;
	}
	else
	{
		nLen = nReadLen;
		close(nHand);
	}

	/*
	CorpID=90009
	SpNum=9868
	LUserName=cctv
	LUserPwd=9868xx
	RUserName=hhs
	RUserPwd=1259061
	SourceID=3000090009
	ClientIP=211.154.46.4
	LocalPort=5089
	ServerIP=202.108.69.10
	ServerPort=5088
	*/
	
	GetValByName((const char *)&"CorpID", (char *)&cBuf, (char *)&m_cCorpID);
	GetValByName((const char *)&"SpNum", (char *)&cBuf, (char *)&m_cSpNum);
	
	GetValByName((const char *)&"LUserName", (char *)&cBuf, (char *)&m_cLUserName);
	GetValByName((const char *)&"LUserPwd", (char *)&cBuf, (char *)&m_cLUserPwd);
	GetValByName((const char *)&"RUserName", (char *)&cBuf, (char *)&m_cRUserName);
	GetValByName((const char *)&"RUserPwd", (char *)&cBuf, (char *)&m_cRUserPwd);
	GetValByName((const char *)&"SourceID", (char *)&cBuf, (char *)&m_cSourceID);
	GetValByName((const char *)&"ClientIP", (char *)&cBuf, (char *)&m_cClientIP);
	GetValByName((const char *)&"ServerIP", (char *)&cBuf, (char *)&m_cServerIP);

	GetValByName((const char *)&"DBAddr", (char *)&cBuf, (char *)&m_cDbAddr);
	GetValByName((const char *)&"DBSrv", (char *)&cBuf, (char *)&m_cDbSrv);
	GetValByName((const char *)&"DBUser", (char *)&cBuf, (char *)&m_cDbUser);
	GetValByName((const char *)&"DBPass", (char *)&cBuf, (char *)&m_cDbPass);
	
	char cTmp[8]="";

	memset(&cTmp, 0, sizeof(cTmp));
	GetValByName((const char *)&"DBPort", (char *)&cBuf, (char *)&cTmp);
	m_nDbPort = atoi(cTmp);

	memset(&cTmp, 0, sizeof(cTmp));
	GetValByName((const char *)&"OperFlag", (char *)&cBuf, (char *)&cTmp);
	m_nOperFlag = atoi(cTmp);
	
	memset(&cTmp, 0, sizeof(cTmp));
	GetValByName((const char *)&"LocalPort", (char *)&cBuf, (char *)&cTmp);
	m_nLocalPort = atoi(cTmp);
	
	memset(&cTmp, 0, sizeof(cTmp));
	GetValByName((const char *)&"ServerPort", (char *)&cBuf, (char *)&cTmp);
	m_nServerPort = atoi(cTmp);
	
	m_bInitConf = true;
	
	return m_bInitConf;
}


