/*
 *
 *
 * GSMPPkg.cpp
 *
 *	ܣƴ
 *
 *
 */



#include "GSMPPkg.h"
#include "SXmlDoc.h"
#include "XmlPaser.h"
#include <wchar.h>
//#include <iconv.h>
int g_nSeqNo;
int PutMsgToXml(void* msg,int cmd,char* xml);
//ת:һֱתΪһֱ
//int code_convert(char *from_charset,char *to_charset,char *inbuf,int inlen,char *outbuf,int outlen);


CGSMPPkg::CGSMPPkg()
{

}

CGSMPPkg::~CGSMPPkg()
{
}

unsigned int CGSMPPkg::GetSeqno(void)
{
	 if (sizeof(int) == 4)
	 {
 		if (g_nSeqNo < 0x7fffffff)
 			g_nSeqNo++;
 		else
 			g_nSeqNo = 0;
	 }
	 else
	 {
		if (g_nSeqNo < 0x7fff)
 			g_nSeqNo++;
 		else
 			g_nSeqNo = 0;	 
	 }
 	
	return g_nSeqNo;
}

int CGSMPPkg::GetPkgHead(const char *pFromTcp, CGSMPHead &mHead)
{
	unsigned char *pTmp = (unsigned char *)pFromTcp;
	if (pTmp == NULL)
		return -1;

	memcpy( (void *)&mHead.nTotalLength, pTmp, sizeof(unsigned int));
	pTmp += sizeof(unsigned int);

	memcpy( (void *)&mHead.nCommandId, pTmp, sizeof(unsigned int));
	pTmp += sizeof(unsigned int);

	memcpy( (void *)&mHead.nSequence, pTmp, sizeof(unsigned short));
	pTmp += sizeof(unsigned short);

	memcpy( (void *)&mHead.nVersion, pTmp, sizeof(unsigned short));
	pTmp += sizeof(unsigned short);

	mHead.nTotalLength = ntohl(mHead.nTotalLength);
	mHead.nCommandId = ntohl(mHead.nCommandId);
	mHead.nSequence = ntohs(mHead.nSequence);
	mHead.nVersion = ntohs(mHead.nVersion);

	return 0;
}


int CGSMPPkg::GetPkgType(const char *pFromtcp)
{
	CGSMPHead mHead;

	if (GetPkgHead(pFromtcp, mHead) == -1)
		return -1;
	
	return mHead.nCommandId;
}


int CGSMPPkg::GetPkgLen(const char *pBuf)
{
	CGSMPHead mHead;

	if (GetPkgHead(pBuf, mHead) == -1)
		return -1;
	
	return mHead.nTotalLength;	
}

int CGSMPPkg::GetPkgSeq(const char *pBuf)
{
	CGSMPHead mHead;

	if (GetPkgHead(pBuf, mHead) == -1)
		return -1;
	
	return mHead.nSequence;	
}

int CGSMPPkg::GetPkgVersion(const char *pBuf)
{
	CGSMPHead mHead;

	if (GetPkgHead(pBuf, mHead) == -1)
		return -1;
	
	return mHead.nTotalLength;	
}

int CGSMPPkg::GetRespResult(const char *pBuf)
{
	if (pBuf == NULL)
		return -1;

	CGSMPHead mHead;
	if (this->GetPkgHead(pBuf, mHead) == -1)
		return -1;

	char *pTmp = (char *)pBuf;
	pTmp += HEAD_SIZE;

	CSXmlDoc *pXmlDoc = new CSXmlDoc("msg");
	pXmlDoc->Parse(pTmp);

	char cResult[10];
	memset(cResult, 0, sizeof(cResult));

	if ((mHead.nCommandId == GSMP_DELIVER_RESP) ||
		(mHead.nCommandId == GSMP_SUBMIT_RESP) ||
		(mHead.nCommandId == GSMP_REPORT_RESP) )
	{
		pXmlDoc->GetItemByName("Result", (char *)cResult);
		delete pXmlDoc;
		if (strlen(cResult) != 0)
			return atoi(cResult);
	}

	delete pXmlDoc;

	return -1;
}


void CGSMPPkg::GetTimeStamp(time_t iTime, char *pTimeStamp)
{
	//char *p = pTimeStamp;
	tm *pTime = localtime(&iTime);
	sprintf(pTimeStamp, "%02d%02d%02d%02d%02d", 
			pTime->tm_mon+1, pTime->tm_mday,
			pTime->tm_hour, pTime->tm_min, pTime->tm_sec);
}

//pBuf->Msg
void CGSMPPkg::ComposePkg
(
	void *pMsg, 
	const char *pBuf,
	int *pPkgType
)
{
	if (pBuf == NULL)
		return;

	char *pTmp = (char *)pBuf;
	CGSMPHead mHead;
	this->GetPkgHead(pTmp, mHead);

	unsigned int nPkgType = mHead.nCommandId;

	if (pPkgType != NULL)
		*pPkgType = mHead.nCommandId;

	pTmp += HEAD_SIZE;
	printf("MSG TYPE:[0x%02x]\n", nPkgType);
	//cout << "INPUT XML:" << pTmp << endl;

	switch (nPkgType)
	{
	case GSMP_LOGIN:
		{
			CGSMPLogin *pLogin = (CGSMPLogin *)pMsg;
			pLogin->InXmlBuf(pTmp);
			pLogin->m_Head.nTotalLength = mHead.nTotalLength;
			pLogin->m_Head.nCommandId = mHead.nCommandId;
			pLogin->m_Head.nSequence = mHead.nSequence;
			pLogin->m_Head.nVersion = mHead.nVersion;
			break;
		}

	case GSMP_LOGIN_RESP:
		{
			CGSMPResp *pLoginResp = (CGSMPResp *)pMsg;
			pLoginResp->InXmlBuf(pTmp);
			pLoginResp->m_Head.nTotalLength = mHead.nTotalLength;
			pLoginResp->m_Head.nCommandId = mHead.nCommandId;
			pLoginResp->m_Head.nSequence = mHead.nSequence;
			pLoginResp->m_Head.nVersion = mHead.nVersion;
			break;
		}

	case GSMP_SUBMIT:
		{
			CGSMPSubmit *pSubmit = (CGSMPSubmit *)pMsg;
			pSubmit->InXmlBuf(pTmp);
			pSubmit->m_Head.nTotalLength = mHead.nTotalLength;
			pSubmit->m_Head.nCommandId = mHead.nCommandId;
			pSubmit->m_Head.nSequence = mHead.nSequence;
			pSubmit->m_Head.nVersion = mHead.nVersion;
			break;
		}

	case GSMP_SUBMIT_RESP:
		{
			CGSMPSubmitResp *pSubmitResp = (CGSMPSubmitResp *)pMsg;
			pSubmitResp->InXmlBuf(pTmp);
			pSubmitResp->m_Head.nTotalLength = mHead.nTotalLength;
			pSubmitResp->m_Head.nCommandId = mHead.nCommandId;
			pSubmitResp->m_Head.nSequence = mHead.nSequence;
			pSubmitResp->m_Head.nVersion = mHead.nVersion;
			break;
		}

	case GSMP_DELIVER:
		{
			CGSMPDeliver *pDeliver = (CGSMPDeliver *)pMsg;
			pDeliver->InXmlBuf(pTmp);
			pDeliver->m_Head.nTotalLength = mHead.nTotalLength;
			pDeliver->m_Head.nCommandId = mHead.nCommandId;
			pDeliver->m_Head.nSequence = mHead.nSequence;
			pDeliver->m_Head.nVersion = mHead.nVersion;
			break;
		}

	case GSMP_DELIVER_RESP:
		{
			CGSMPResp *pDelResp = (CGSMPResp *)pMsg;
			pDelResp->InXmlBuf(pTmp);
			pDelResp->m_Head.nTotalLength = mHead.nTotalLength;
			pDelResp->m_Head.nCommandId = mHead.nCommandId;
			pDelResp->m_Head.nSequence = mHead.nSequence;
			pDelResp->m_Head.nVersion = mHead.nVersion;
			break;
		}

	case GSMP_REPORT:
		{
			CGSMPReport *pReport = (CGSMPReport *)pMsg;
			pReport->InXmlBuf(pTmp);
			pReport->m_Head.nTotalLength = mHead.nTotalLength;
			pReport->m_Head.nCommandId = mHead.nCommandId;
			pReport->m_Head.nSequence = mHead.nSequence;
			pReport->m_Head.nVersion = mHead.nVersion;
			break;
		}

	case GSMP_REPORT_RESP:
		{
			CGSMPResp *pRptResp = (CGSMPResp *)pMsg;
			pRptResp->InXmlBuf(pTmp);
			pRptResp->m_Head.nTotalLength = mHead.nTotalLength;
			pRptResp->m_Head.nCommandId = mHead.nCommandId;
			pRptResp->m_Head.nSequence = mHead.nSequence;
			pRptResp->m_Head.nVersion = mHead.nVersion;
			break;
		}
	
	case GSMP_TERMINATE:
		//break;
	case GSMP_TERMINATE_RESP:
		//break;
	case GSMP_QLINK:
		//break;
	case GSMP_QLINK_RESP:
		//break;
	default:
		{
			/*
			unsigned char *pBase = (unsigned char *)pMsg;
			memcpy(pBase, (void *)&mHead.nTotalLength, sizeof(unsigned int));
			pBase += sizeof(unsigned int);
			memcpy(pBase, (void *)&mHead.nCommandId, sizeof(unsigned int));
			pBase += sizeof(unsigned int);
			memcpy(pBase, (void *)&mHead.nSequence, sizeof(unsigned short));
			pBase += sizeof(unsigned short);
			memcpy(pBase, (void *)&mHead.nVersion, sizeof(unsigned short));
			*/

			CGSMPHead *pHead = (CGSMPHead *)pMsg;
			pHead->nTotalLength = mHead.nTotalLength;
			pHead->nCommandId = mHead.nCommandId;
			pHead->nSequence = mHead.nSequence;
			pHead->nVersion = mHead.nVersion;
			break;
		}		
	}

	return;
}

//ֽMsg->pBuf
void CGSMPPkg::DeComposePkg
(
	unsigned int nPkgType, 
	void *pMsg, 
	char *pBuf,
	int *pLen
)
{
	if (pBuf == NULL)
		return;

	*pLen = 0;

	CGSMPHead mHead;
	char cBuf[5120];
	memset(cBuf, 0, sizeof(cBuf));

	switch (nPkgType)
	{
	case GSMP_LOGIN:
		{
			CGSMPLogin *pLogin = (CGSMPLogin *)pMsg;
			PutMsgToXml(pLogin,GSMP_LOGIN,cBuf);
			//pLogin->OutXmlBuf((char *)cBuf);
			mHead.nCommandId = pLogin->m_Head.nCommandId;
			mHead.nSequence = pLogin->m_Head.nSequence;
			//mHead.nTotalLength = pLogin->m_Head.nTotalLength;
			mHead.nVersion = pLogin->m_Head.nVersion;
			break;
		}

	case GSMP_LOGIN_RESP:
		{
			CGSMPResp *pLoginResp = (CGSMPResp *)pMsg;
			PutMsgToXml(pLoginResp,GSMP_LOGIN_RESP,cBuf);
			//pLoginResp->OutXmlBuf((char *)cBuf);
			mHead.nCommandId = pLoginResp->m_Head.nCommandId;
			mHead.nSequence = pLoginResp->m_Head.nSequence;
			//mHead.nTotalLength = pLoginResp->m_Head.nTotalLength;
			mHead.nVersion = pLoginResp->m_Head.nVersion;
			break;
		}

	case GSMP_SUBMIT:
		{
			CGSMPSubmit *pSubmit = (CGSMPSubmit *)pMsg;
			PutMsgToXml(pMsg,GSMP_SUBMIT,cBuf);
			//pSubmit->OutXmlBuf((char *)cBuf);
			mHead.nCommandId = pSubmit->m_Head.nCommandId;
			mHead.nSequence = pSubmit->m_Head.nSequence;
			//mHead.nTotalLength = pSubmit->m_Head.nTotalLength;
			mHead.nVersion = pSubmit->m_Head.nVersion;
			break;
		}

	case GSMP_SUBMIT_RESP:
		{
			CGSMPSubmitResp *pSubmitResp = (CGSMPSubmitResp *)pMsg;
			//pSubmitResp->OutXmlBuf((char *)cBuf);
			PutMsgToXml(pMsg,GSMP_SUBMIT_RESP,cBuf);
			mHead.nCommandId = pSubmitResp->m_Head.nCommandId;
			mHead.nSequence = pSubmitResp->m_Head.nSequence;
			//mHead.nTotalLength = pSubmitResp->m_Head.nTotalLength;
			mHead.nVersion = pSubmitResp->m_Head.nVersion;
			break;
		}

	case GSMP_DELIVER:
		{
			CGSMPDeliver *pDeliver = (CGSMPDeliver *)pMsg;
			//pDeliver->OutXmlBuf((char *)cBuf);
			PutMsgToXml(pMsg,GSMP_DELIVER,cBuf);
			mHead.nCommandId = pDeliver->m_Head.nCommandId;
			mHead.nSequence = pDeliver->m_Head.nSequence;
			//mHead.nTotalLength = pDeliver->m_Head.nTotalLength;
			mHead.nVersion = pDeliver->m_Head.nVersion;
			break;
		}

	case GSMP_DELIVER_RESP:
		{
			CGSMPResp *pDelResp = (CGSMPResp *)pMsg;
			PutMsgToXml(pMsg,GSMP_DELIVER_RESP,cBuf);
			//pDelResp->OutXmlBuf((char *)cBuf);
			mHead.nCommandId = pDelResp->m_Head.nCommandId;
			mHead.nSequence = pDelResp->m_Head.nSequence;
			//mHead.nTotalLength = pDelResp->m_Head.nTotalLength;
			mHead.nVersion = pDelResp->m_Head.nVersion;
			break;
		}

	case GSMP_REPORT:
		{
			CGSMPReport *pReport = (CGSMPReport *)pMsg;
			PutMsgToXml(pMsg,GSMP_REPORT,cBuf);
			//pReport->OutXmlBuf((char *)cBuf);
			mHead.nCommandId = pReport->m_Head.nCommandId;
			mHead.nSequence = pReport->m_Head.nSequence;
			//mHead.nTotalLength = pReport->m_Head.nTotalLength;
			mHead.nVersion = pReport->m_Head.nVersion;
			break;
		}

	case GSMP_REPORT_RESP:
		{
			CGSMPResp *pRptResp = (CGSMPResp *)pMsg;
			PutMsgToXml(pMsg,GSMP_REPORT_RESP,cBuf);
			//pRptResp->OutXmlBuf((char *)cBuf);
			mHead.nCommandId = pRptResp->m_Head.nCommandId;
			mHead.nSequence = pRptResp->m_Head.nSequence;
			//mHead.nTotalLength = pRptResp->m_Head.nTotalLength;
			mHead.nVersion = pRptResp->m_Head.nVersion;
			break;
		}

	case GSMP_TERMINATE:
		//break;
	case GSMP_TERMINATE_RESP:
		//break;
	case GSMP_QLINK:
		//break;
	case GSMP_QLINK_RESP:
		//break;
	default:
		{
			/*
			unsigned char *pTmp = (unsigned char *)pMsg;
			memcpy((void *)&mHead.nTotalLength, pTmp, sizeof(unsigned int));
			pTmp += sizeof(unsigned int);
			memcpy((void *)&mHead.nCommandId, pTmp, sizeof(unsigned int));
			pTmp += sizeof(unsigned int);
			memcpy((void *)&mHead.nSequence, pTmp, sizeof(unsigned short));
			pTmp += sizeof(unsigned short);
			memcpy((void *)&mHead.nVersion, pTmp, sizeof(unsigned short));
			*/
			CGSMPHead *pHead = (CGSMPHead *)pMsg;
			mHead.nCommandId = pHead->nCommandId;
			mHead.nSequence = pHead->nSequence;
			mHead.nTotalLength = HEAD_SIZE;
			//mHead.nVersion = pHead->nVersion;
			break;
		}
	}
	cout<<"SNDXML::"<<cBuf<<endl;
	*pLen = HEAD_SIZE + strlen(cBuf);
	mHead.nTotalLength = HEAD_SIZE + strlen(cBuf);
/*
	mHead.nCommandId = ntohl(mHead.nCommandId);
	mHead.nSequence = ntohs(mHead.nSequence);
	mHead.nTotalLength = ntohl(mHead.nTotalLength);
	mHead.nVersion = ntohs(mHead.nVersion);
*/
//	printf("befor==============len:%d, seq:%d, command:%d,version:%d\n", mHead.nTotalLength, mHead.nSequence, mHead.nCommandId,mHead.nVersion);
	mHead.nCommandId = htonl(mHead.nCommandId);
	mHead.nSequence = htons(mHead.nSequence);
	mHead.nTotalLength = htonl(mHead.nTotalLength);
	mHead.nVersion = htons(mHead.nVersion);

	unsigned char *pBase = (unsigned char *)pBuf;
	memcpy(pBase, (void *)&mHead.nTotalLength, sizeof(unsigned int));
	pBase += sizeof(unsigned int);
	memcpy(pBase, (void *)&mHead.nCommandId, sizeof(unsigned int));
	pBase += sizeof(unsigned int);
	memcpy(pBase, (void *)&mHead.nSequence, sizeof(unsigned short));
	pBase += sizeof(unsigned short);
	memcpy(pBase, (void *)&mHead.nVersion, sizeof(unsigned short));
	pBase += sizeof(unsigned short);

	memcpy(pBase, &cBuf,  strlen(cBuf));

	printf("MSG TYPE:[0x%02x] LEN = [%d]\n", nPkgType, *pLen);
//	printf("after===============len:%d, seq:%d, command:%d,version:%d\n", mHead.nTotalLength, mHead.nSequence, mHead.nCommandId,mHead.nVersion);
	//cout << "OUT XML:" << cBuf << endl;

	return;
}

int PutMsgToXml(void* pMsg,int cmd,char* xml)
{
	XmlWriter w("msg");
	switch(cmd)
	{
	case GSMP_LOGIN:
		{
			CGSMPLogin *pLogin = (CGSMPLogin *)pMsg;
			Element User("User");
			User.SetText(pLogin->m_sUser.c_str());
			Element Password("Password");
			Password.SetText(pLogin->m_sPassword.c_str());
			Element LoginType("LoginType");
			LoginType.SetText(pLogin->m_sLoginType.c_str());

			w.AppendElement(&User);
			w.AppendElement(&Password);
			w.AppendElement(&LoginType);
			break;
		}

	case GSMP_LOGIN_RESP:
		{
			CGSMPResp *pLoginResp = (CGSMPResp *)pMsg;
			Element Result("Result");
			Result.SetText(pLoginResp->m_sResult.c_str());
			w.AppendElement(&Result);
			break;
		}

	case GSMP_SUBMIT:
		{
			CGSMPSubmit *pSubmit = (CGSMPSubmit *)pMsg;
			Element MsgType("MsgType");
			MsgType.SetText(pSubmit->m_sMsgType.c_str());
			w.AppendElement(&MsgType);

			Element MsgId("MsgId");
			MsgId.SetText(pSubmit->m_sMsgId.c_str());
			w.AppendElement(&MsgId);

			Element SrcGWId("SrcGWId");
			SrcGWId.SetText(pSubmit->m_sSrcGWId.c_str());
			w.AppendElement(&SrcGWId);

			Element SrcTermId("SrcTermId");
			SrcTermId.SetText(pSubmit->m_sSrcTermId.c_str());
			w.AppendElement(&SrcTermId);

			Element ChargeTermId("ChargeTermId");
			ChargeTermId.SetText(pSubmit->m_sChargeTermId.c_str());
			w.AppendElement(&ChargeTermId);

			Element ChargeTermType("ChargeTermType");
			ChargeTermType.SetText(pSubmit->m_sChargeTermType.c_str());
			w.AppendElement(&ChargeTermType);

			Element DestTermCount("DestTermCount");
			DestTermCount.SetText(pSubmit->m_sDestTermCount.c_str());
			w.AppendElement(&DestTermCount);

			Element DestTermId("DestTermId");
			DestTermId.SetText(pSubmit->m_sDestTermId.c_str());
			w.AppendElement(&DestTermId);

			Element DestTermType("DestTermType");
			DestTermType.SetText(pSubmit->m_sDestTermType.c_str());
			w.AppendElement(&DestTermType);

			Element ServiceId("ServiceId");
			ServiceId.SetText(pSubmit->m_sServiceId.c_str());
			w.AppendElement(&ServiceId);

			Element FeeType("FeeType");
			FeeType.SetText(pSubmit->m_sFeeType.c_str());
			w.AppendElement(&FeeType);

			Element FeeCode("FeeCode");
			FeeCode.SetText(pSubmit->m_sFeeCode.c_str());
			w.AppendElement(&FeeCode);

			Element GivenValue("GivenValue");
			GivenValue.SetText(pSubmit->m_sGivenValue.c_str());
			w.AppendElement(&GivenValue);

			Element MTF("MTF");
			MTF.SetText(pSubmit->m_sMTF.c_str());
			w.AppendElement(&MTF);

			Element MsgLevel("MsgLevel");
			MsgLevel.SetText(pSubmit->m_sMsgLevel.c_str());
			w.AppendElement(&MsgLevel);

			Element ValidTime("ValidTime");
			ValidTime.SetText(pSubmit->m_sValidTime.c_str());
			w.AppendElement(&ValidTime);

			Element AtTime("AtTime");
			AtTime.SetText(pSubmit->m_sAtTime.c_str());
			w.AppendElement(&AtTime);

			Element NeedReport("NeedReport");
			NeedReport.SetText(pSubmit->m_sNeedReport.c_str());
			w.AppendElement(&NeedReport);

			Element TPpid("TPpid");
			TPpid.SetText(pSubmit->m_sTPpid.c_str());
			w.AppendElement(&TPpid);

			Element TPudhi("TPudhi");
			TPudhi.SetText(pSubmit->m_sTPudhi.c_str());
			w.AppendElement(&TPudhi);

			Element MsgFmt("MsgFmt");
			MsgFmt.SetText(pSubmit->m_sMsgFmt.c_str());
			w.AppendElement(&MsgFmt);

			Element MsgContType("MsgContType");
			MsgContType.SetText(pSubmit->m_sMsgContType.c_str());
			w.AppendElement(&MsgContType);

			Element MsgCont("MsgCont");
			MsgCont.SetText(pSubmit->m_sMsgCont.c_str());
			w.AppendElement(&MsgCont);

			Element LinkId("LinkId");
			LinkId.SetText(pSubmit->m_sLinkId.c_str());
			w.AppendElement(&LinkId);

			break;
		}

	case GSMP_SUBMIT_RESP:
		{
			CGSMPSubmitResp *pSubmitResp = (CGSMPSubmitResp *)pMsg;
			Element Msgid("Msgid");
			Msgid.SetText(pSubmitResp->m_sMsgid.c_str());
			w.AppendElement(&Msgid);

			Element Result("Result");
			Result.SetText(pSubmitResp->m_sResult.c_str());
			w.AppendElement(&Result);
			break;
		}

	case GSMP_DELIVER:
		{
			CGSMPDeliver *pDeliver = (CGSMPDeliver *)pMsg;
			Element MsgType("MsgType");
			MsgType.SetText(pDeliver->m_sMsgType.c_str());
			w.AppendElement(&MsgType);

			Element MsgId("MsgId");
			MsgId.SetText(pDeliver->m_sMsgId.c_str());
			w.AppendElement(&MsgId);

			Element SrcGWId("SrcGWId");
			SrcGWId.SetText(pDeliver->m_sSrcGWId.c_str());
			w.AppendElement(&SrcGWId);

			Element DestGWId("DestGWId");
			DestGWId.SetText(pDeliver->m_sDestGWId.c_str());
			w.AppendElement(&DestGWId);

			Element SrcTermId("SrcTermId");
			SrcTermId.SetText(pDeliver->m_sSrcTermId.c_str());
			w.AppendElement(&SrcTermId);

			Element SrcTermType("SrcTermType");
			SrcTermType.SetText(pDeliver->m_sSrcTermType.c_str());
			w.AppendElement(&SrcTermType);

			Element DestTermId("DestTermId");
			DestTermId.SetText(pDeliver->m_sDestTermId.c_str());
			w.AppendElement(&DestTermId);

			Element ServiceId("ServiceId");
			ServiceId.SetText(pDeliver->m_sServiceId.c_str());
			w.AppendElement(&ServiceId);

			Element MsgLevel("MsgLevel");
			MsgLevel.SetText(pDeliver->m_sMsgLevel.c_str());
			w.AppendElement(&MsgLevel);

			Element MsgFmt("MsgFmt");
			MsgFmt.SetText(pDeliver->m_sMsgFmt.c_str());
			w.AppendElement(&MsgFmt);

			Element MsgContType("MsgContType");
			MsgContType.SetText(pDeliver->m_sMsgContType.c_str());
			w.AppendElement(&MsgContType);

			Element MsgCont("MsgCont");
//			char cMsgContentGB2312[512];
//			code_convert("ISO-8859-1","GB2312",(char*)pDeliver->m_sMsgCont.c_str(),(int)pDeliver->m_sMsgCont.size(),cMsgContentGB2312,512);
//			MsgCont.SetText(cMsgContentGB2312);
			MsgCont.SetText(pDeliver->m_sMsgCont.c_str());
			w.AppendElement(&MsgCont);

			Element LinkId("LinkId");
			LinkId.SetText(pDeliver->m_sLinkId.c_str());
			w.AppendElement(&LinkId);
			break;
		}

	case GSMP_DELIVER_RESP:
		{
			CGSMPResp *pDelResp = (CGSMPResp *)pMsg;
			Element Result("Result");
			Result.SetText(pDelResp->m_sResult.c_str());
			w.AppendElement(&Result);

			break;
		}

	case GSMP_REPORT:
		{
			CGSMPReport *pReport = (CGSMPReport *)pMsg;
			Element MsgType("MsgType");
			MsgType.SetText(pReport->m_sMsgType.c_str());
			w.AppendElement(&MsgType);

			Element MsgId("MsgId");
			MsgId.SetText(pReport->m_sMsgId.c_str());
			w.AppendElement(&MsgId);

			Element SubmitMsgId("SubmitMsgId");
			SubmitMsgId.SetText(pReport->m_sSubmitMsgId.c_str());
			w.AppendElement(&SubmitMsgId);

			Element DestTermId("DestTermId");
			DestTermId.SetText(pReport->m_sDestTermId.c_str());
			w.AppendElement(&DestTermId);

			Element Stat("Stat");
			Stat.SetText(pReport->m_sStat.c_str());
			w.AppendElement(&Stat);

			Element SubmitTime("SubmitTime");
			SubmitTime.SetText(pReport->m_sSubmitTime.c_str());
			w.AppendElement(&SubmitTime);

			Element DoneTime("DoneTime");
			DoneTime.SetText(pReport->m_sDoneTime.c_str());
			w.AppendElement(&DoneTime);

			break;
		}

	case GSMP_REPORT_RESP:
		{
			CGSMPResp *pRptResp = (CGSMPResp *)pMsg;
			Element Result("Result");
			Result.SetText(pRptResp->m_sResult.c_str());
			w.AppendElement(&Result);
			break;
		}
	}
	strcpy(xml,w.ToXmlStr().c_str());
	return 0;
}

/*//ת:һֱתΪһֱ
int code_convert(char *from_charset,char *to_charset,char *inbuf,int inlen,char *outbuf,int outlen)
{
	iconv_t cd;
	int rc;
	char **pin = &inbuf;
	char **pout = &outbuf;

	cd = iconv_open(to_charset,from_charset);
	if (cd==0) return -1;
	memset(outbuf,0,outlen);
	if (iconv(cd,pin,(size_t*)&inlen,pout,(size_t*)&outlen)==-1) return -1;
	iconv_close(cd);
	return 0;
}*/

