// UCSPXmlDoc.cpp: implementation of the CSXmlDoc class.
//
//////////////////////////////////////////////////////////////////////

#include "SXmlDoc.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CSXmlDoc::CSXmlDoc()
{
	m_strRootNode = "";
	m_strRootName = "";
	m_strRootValue = "";
}
CSXmlDoc::CSXmlDoc(const char* chsRootNode, const char* chsRootName, const char* chsRootValue)
{
	m_strRootNode = chsRootNode;
	m_strRootName = chsRootName;
	m_strRootValue = chsRootValue;
	m_strVersion = "1.0";
	Create();
}
CSXmlDoc::~CSXmlDoc()
{
}

bool CSXmlDoc::Create()
{
	// һյİ
	char temp[500];
	memset(temp, 0 ,sizeof(temp));
	strcpy(temp, "<?xml");
	//sprintf(temp,"<?xml");		
	if(m_strVersion.length() > 0)
	{
		strcat(temp, " version=\"");
		strcat(temp, m_strVersion.c_str());
		strcat(temp, "\"");
	}

	if(m_strEncoding.length() > 0)
	{
		strcat(temp, " encoding=\"");
		strcat(temp, m_strEncoding.c_str());
		strcat(temp, "\"");
	}

	if(m_strStandAlong.length() > 0)
	{
		strcat(temp, " standalong=\"");
		strcat(temp, m_strStandAlong.c_str());
		strcat(temp, "\"");
	}

	strcat(temp, "?>\n");

	if(m_strRootNode.length() == 0)
	{
		m_strRootNode == "root";
	}
	strcat(temp , "<");
	strcat(temp, m_strRootNode.c_str());
	
	if(m_strRootName.length() > 0)
	{
		strcat(temp, " ");
		strcat(temp, m_strRootName.c_str());
		strcat(temp, "=\"");
		strcat(temp, m_strRootValue.c_str());
		strcat(temp, "\"");
	}
	strcat(temp, ">\n");
	strcat(temp, "</");
	strcat(temp, m_strRootNode.c_str());
	strcat(temp, ">\n");

/*
	sprintf(temp, "<?xml version=\"1.0\" ?>\n"
				  "<%s %s=\"%s\">\n"
				  "</%s>\n", m_strRootNode.c_str(), m_strRootName.c_str(), m_strRootValue.c_str(), m_strRootNode.c_str());
*/
	return Parse(temp);
	
}
void CSXmlDoc::Save(const char* chsFileName)
{
	if(!chsFileName)
		m_tXmlDoc.SaveFile();
	else
		m_tXmlDoc.SaveFile(chsFileName);

}

bool CSXmlDoc::Parse(const char * str, const int type)
{
	// ļļXML
	if(type != 0){
		if(!m_tXmlDoc.LoadFile(str)){
			printf( "Could not load file '%s'. Error='%s'. Exiting.\n", str, m_tXmlDoc.ErrorDesc());
			return false;	
		}
		// ִַXML
	}else{
		m_tXmlDoc.Parse(str);
		if(m_tXmlDoc.Error()){
			printf("------Error Xml format!!!------\n");
			return false;
		}
	}

	TiXmlElement*	elemRoot = m_tXmlDoc.RootElement();
	if(elemRoot)
		m_strRootNode = elemRoot->Value();

	return true;	
}
void CSXmlDoc::InsertItem(const char *name, const char *value, int pos)
{
	TiXmlNode*		nodeRoot = NULL;

	nodeRoot = m_tXmlDoc.FirstChild(m_strRootNode);
	if(nodeRoot)
	{
		TiXmlElement	elemField(name);
		TiXmlText		textValue(value);

		elemField.InsertEndChild(textValue);
		nodeRoot->InsertEndChild(elemField);
	}
}
void CSXmlDoc::InsertItem(const char* name, const int nValue, int pos)
{
	TiXmlNode*		nodeRoot = NULL;
	char chsValue[64];
	sprintf(chsValue, "%d", nValue);
	nodeRoot = m_tXmlDoc.FirstChild(m_strRootNode);
	if(nodeRoot)
	{
		TiXmlElement	elemField(name);
		TiXmlText		textValue(chsValue);

		elemField.InsertEndChild(textValue);
		nodeRoot->InsertEndChild(elemField);
	}	
}
void CSXmlDoc::InsertItem(const char* name, const char chValue, int pos)
{
	TiXmlNode*		nodeRoot = NULL;

	char chsValue[2];
	sprintf(chsValue, "%c", chValue);
	nodeRoot = m_tXmlDoc.FirstChild(m_strRootNode);
	if(nodeRoot)
	{
		TiXmlElement	elemField(name);
		TiXmlText		textValue(chsValue);

		elemField.InsertEndChild(textValue);
		nodeRoot->InsertEndChild(elemField);
	}		
}
bool CSXmlDoc::GetItemByName(const char *name, char *value, int pos)
{
	TiXmlNode*		nodeRoot = NULL;
	TiXmlElement*	elemField = NULL;

	nodeRoot = m_tXmlDoc.FirstChild(m_strRootNode);
	if(nodeRoot)
	{
		elemField = nodeRoot->FirstChildElement(name);

		if(elemField)
		{
			TiXmlNode* nodeValue = elemField->FirstChild();
			if(!nodeValue)
			{
				strcpy(value, "");
				return true;
			}

			TiXmlText* textValue = nodeValue->ToText();
			if(!textValue)
			{
				strcpy(value, "");
				return true;
			}

			strcpy(value, textValue->Value());
			return true;
		}
	}
	return false;
}
bool CSXmlDoc::GetItemByName(const char *name, int& value, int pos)
{
	TiXmlNode*		nodeRoot = NULL;
	TiXmlElement*	elemField = NULL;
	
	nodeRoot = m_tXmlDoc.FirstChild(m_strRootNode);
	if(nodeRoot)
	{
		elemField = nodeRoot->FirstChildElement(name);
		
		if(elemField)
		{
			TiXmlNode* nodeValue = elemField->FirstChild();
			if(!nodeValue)
			{
				return true;
			}

			TiXmlText* textValue = nodeValue->ToText();
			if(!textValue)
			{
				return true;
			}

			value = atoi(textValue->Value());
			return true;
		}
	}
	return false;
}
bool CSXmlDoc::RemoveItemByName(const char *name, int pos)
{
	TiXmlNode*		nodeRoot = NULL;
	TiXmlElement*	elemField = NULL;
	
	nodeRoot = m_tXmlDoc.FirstChild(m_strRootNode);
	if(nodeRoot)
	{
		elemField = nodeRoot->FirstChildElement(name);
		
		if(elemField)
		{
			nodeRoot->RemoveChild(elemField);
			return true;
		}
	}
	return false;
}
bool CSXmlDoc::UpdateItemByName(const char *name, const char *value, int pos)
{
	TiXmlNode*		nodeRoot = NULL;
	TiXmlElement*	elemField = NULL;
	
	nodeRoot = m_tXmlDoc.FirstChild(m_strRootNode);
	if(nodeRoot)
	{
		elemField = nodeRoot->FirstChildElement(name);
		
		if(elemField)
		{
			TiXmlElement	elemFieldNew(name);
			TiXmlText		textValueNew(value);
			
			elemFieldNew.InsertEndChild(textValueNew);
			nodeRoot->ReplaceChild(elemField, elemFieldNew);
			return true;
		}
	}
	return false;
}
/*-----------------------------------------
ܣXMLַ
	
ֵXMLַ
޸ʱ䣺2002-12-19 
-----------------------------------------*/
const char *CSXmlDoc::GetXmlChar(void)
{
#ifdef TIXML_USE_STL
	ostrstream os;
	os << m_tXmlDoc;
	return os.str();
#else
	return "";
#endif
}

/*-----------------------------------------
ܣXMLַ
	valueXMLַ
ֵ
޸ʱ䣺2002-12-19 
-----------------------------------------*/
void CSXmlDoc::GetXmlChar(char *value)
{
#ifdef TIXML_USE_STL
	ostrstream os;
	os << m_tXmlDoc;
	strcpy(value, os.str() );
#endif
}
/*-----------------------------------------
ܣӡXMLַ
	
ֵ
޸ʱ䣺2002-12-19 
-----------------------------------------*/
void CSXmlDoc::Print(void)
{
	m_tXmlDoc.Print(stdout);
//	m_tXmlDoc.Print();
}


