// UCSPXmlDoc.h: interface for the CSXmlDoc class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SXMLDOC_H__09EEBA7F_FF75_4DE8_8249_E454DE9E45D7__INCLUDED_)
#define AFX_UCSPXMLDOC_H__09EEBA7F_FF75_4DE8_8249_E454DE9E45D7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include "BLibLinux.h"
#include "tinyxml.h"

#ifdef TIXML_USE_STL
	using namespace std;
	#include <iostream>
	#include <sstream>
	#include <strstream>
#else
	#include <stdio.h>
#endif


class CSXmlDoc  
{
public:
	CSXmlDoc();
	CSXmlDoc(const char* chsRootNode, const char* chsRootName="", const char* chsRootValue="");
	virtual ~CSXmlDoc();

protected:
	
	TIXML_STRING	m_strVersion;
	TIXML_STRING	m_strEncoding;
	TIXML_STRING	m_strStandAlong;

	TIXML_STRING	m_strRootNode;
	TIXML_STRING	m_strRootName;
	TIXML_STRING	m_strRootValue;

protected:
    TiXmlDocument   m_tXmlDoc;		// XMLĵ

public:
	void SetDeclaration(const char* chsVersion = "", const char* chsEncoding = "", const char* chsStandAlong = "")
	{
		m_strVersion = chsVersion;
		m_strEncoding = chsEncoding;
		m_strStandAlong = chsStandAlong;
	}
	void SetRoot(const char* chsRootNode, const char* chsRootName = "", const char* chsRootValue = "")
	{
		m_strRootNode = chsRootNode;
		m_strRootName = chsRootName;
		m_strRootValue = chsRootValue;
	}
	
	bool Create();
	void Save(const char* chsFileName);
	bool Parse(const char * str, const int type = 0);
    const char *GetXmlChar(void);
    void GetXmlChar(char *);

    void Print(void);

    void InsertItem(const char *name, const char *value, int pos = 1);
    void InsertItem(const char *name, const int, int pos = 1);
    void InsertItem(const char *name, const char, int pos = 1);
    bool GetItemByName(const char *, char *, int pos = 1);
    bool GetItemByName(const char *, int&, int pos = 1);
    bool RemoveItemByName(const char *, int pos = 1);
    bool UpdateItemByName(const char *, const char*, int pos = 1);	
};

#endif // !defined(AFX_SXMLDOC_H__09EEBA7F_FF75_4DE8_8249_E454DE9E45D7__INCLUDED_)


