#include "tinyxml.h"

#ifdef TIXML_USE_STL
        using namespace std;
        #include <iostream>
        #include <sstream>
        #include <strstream>
#else
        #include <stdio.h>
#endif

#ifndef __XMLDOCBASE__
#define __XMLDOCBASE__

// ְṹ
const unsigned int PACKET_SMT       = 0x00000000;
const unsigned int PACKET_SMO       = 0x00000001;
const unsigned int PACKET_AUS       = 0x00000002;
const unsigned int PACKET_MMT       = 0x00000003;
const unsigned int PACKET_ACK		= 0x00000005;
const unsigned int PACKET_FIN		= 0x00000004;
const unsigned int PACKET_REP	    = 0x00000006;
const unsigned int PACKET_MSHMT		= 0x00000007;
const unsigned int PACKET_MSHRE		= 0x00000008;

const unsigned int PACKET_SMT_RESP  = 0x80000000;
const unsigned int PACKET_SMO_RESP  = 0x80000001;
const unsigned int PACKET_AUS_RESP  = 0x80000002;
const unsigned int PACKET_MMT_RESP  = 0x80000003;
const unsigned int PACKET_ACK_RESP	= 0x80000005;
const unsigned int PACKET_FIN_RESP  = 0x80000004;
const unsigned int PACKET_REP_RESP	= 0x80000006;

const unsigned int PACKET_GEN       = 0x00000010;

////////////////////////////////////////////////
//	CXmlDocBase
//	๦ܣXMLݰ
//	ߣ·
//	ʱ䣺2002-12-19
////////////////////////////////////////////////

class CXmlDocBase
{
public:
    CXmlDocBase(){ m_iFormNum = 0; };
    CXmlDocBase(const int);
    virtual ~CXmlDocBase();

protected:
    int         m_iMsgType;			// 
	char 		m_RootNode[20];		// ڵ
	char		m_HeadNode[20];		// ͷڵ
	char		m_BodyNode[20];		// ڵ
	char 		m_RootName[20];		// 
	char 		m_HeadName[20];		// ͷ
	char 		m_BodyName[20];		// 
	char 		m_NodeName[20];		// ӽڵ

	int			m_iFormNum;			// 
    TiXmlDocument   m_tXmlDoc;		// XMLʵ
    TiXmlElement    *m_eHead;		// ͷڵָ
    TiXmlElement    *m_eBody;		// ڵָ

	TiXmlElement 	**m_eForm;		// ָ
	ostringstream m_outputStream;
protected:
    void SetRoot(const char *, const char *);
    void SetHead(const char *, const char *);
    void SetBody(const char *, const char *);
    bool GetTypeAndBody(void);
	void SetType(const int);

	// ðԵĳ󷽷
    virtual bool SetProperty() = 0;

public:
    bool Parse(const char *, const int type = 0);
    const char *GetXmlChar(void);
    void GetXmlChar(char *);
    void Print(void);
    int  GetType(void);
    void ChangeType(const int);

    void InsertItem(const char *name, const char *value, int pos = 1);
    void InsertItem(const char *name, const int, int pos = 1);
    void InsertItem(const char *name, const char, int pos = 1);
    bool GetItemByName(const char *, char *, int pos = 1);
    bool GetItemByName(const char *, int&, int pos = 1);
    bool RemoveItemByName(const char *, int pos = 1);
    bool UpdateItemByName(const char *, const char*, int pos = 1);

	virtual void InsertForm(const char *, const char *){};
	virtual void InsertFormItem(const char *, const char *, const int pos){};
	virtual void InsertFormItem(const int, const char *, const char *, const int pos){};
	virtual void GetFormItemByID(const int id, char *, char *, const int pos){};
	virtual void GetFormItemByName(const char *, char *, const int pos){};
};

#endif



/*
$Author: pentaho $
$LastChangedDate$
$Rev$
*/


/*
$Author: pentaho $
$LastChangedDate$
$Rev$
*/
