package com.wisentsoft.test;



import java.net.SocketTimeoutException;

import com.wisentsoft.service.sms.gsmp.data.GsmpDeliver;
import com.wisentsoft.service.sms.gsmp.data.GsmpReport;
import com.wisentsoft.service.sms.gsmp.exception.ConfigFileNotFoundException;
import com.wisentsoft.service.sms.gsmp.exception.ConnectionAlreadyCloseedException;
import com.wisentsoft.service.sms.gsmp.exception.ConnectionAreadyConnectedException;
import com.wisentsoft.service.sms.gsmp.exception.GSMPIllegalStateException;
import com.wisentsoft.service.sms.gsmp.exception.GSMPNetException;
import com.wisentsoft.service.sms.gsmp.proxy.GSMPProxy;
/**
 * GSMP clientJava
 * @version gsmp_2.2
 * @author chengtl
 * 
 */
public class GsmpClientTest { 
	public static int MAX_RECIEVE_LENGTH=10;
	
	/**
	 * @param args
	 * @throws ConnectionAreadyConnectedException 
	 * @throws IllegalArgumentException 
	 * @throws ConfigFileNotFoundException 
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		System.out.println("=============>main,start====================");
		GSMPProxy proxy = new GSMPProxy();
		String ip="ipַϵԽԱȡ";
		int port=6685;
		String user="<cpcorpidϵͳϵԽԱȡ>";
		String passwd="<cppasswdϵͳϵԽԱȡ>";
		try {
			proxy.connect(ip, port, user, passwd, 30, "./wisent_log.properties");
		} catch (ConfigFileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			return ;
		} catch (IllegalArgumentException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			return ;
		} catch (ConnectionAreadyConnectedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		new DeliverThread(proxy).start();
		new ReportThread(proxy).start();
		new SubmitThread(proxy).start();
		new SubmitThread(proxy).start();
		new SubmitThread(proxy).start();
	}
	public static void echo(String s){
		System.out.println(s) ;
	}
	
	public static void echoline(String s){
		System.out.print(s) ;
	}
	
}
class SubmitThread extends Thread{
	private GSMPProxy proxy;
	public SubmitThread(GSMPProxy proxy){
		this.proxy=proxy;
	}
	public void run(){
		String phone, content ;
		String extCode = "565" ;
		String cpSrvId="cpҵϵԽԱȡ";
		System.out.println("===========>"+cpSrvId);
		String res;
		while(true){
			try {
				res = proxy.submitMTSMS("дŽֻ", "ǲԶ",cpSrvId,extCode);
				GsmpClientTest.echo("submit response : " + res) ;
				
			} catch (Exception e) {
				// TODO Auto-generated catch block
				
				e.printStackTrace();
				try {
					proxy.reConnect();
				} catch (ConnectionAreadyConnectedException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				continue;
			}
			try {
				Thread.sleep(1000*60);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
}
class DeliverThread extends Thread{
	/**
	 * Ǵжẉ̂߳ǻȡжǴӶȡģGSMP Server ͨŻȡж<br/>
	 * ԶƣԴ˴ҪǷGSMP Server
	 */
	private GSMPProxy proxy;
	public DeliverThread(GSMPProxy proxy){
		this.proxy=proxy;
	}
	
	public void run(){
		System.out.println("DeliverThread thread start.....");
		while(true){
			
			GsmpDeliver[] mos=proxy.getDelivers(GsmpClientTest.MAX_RECIEVE_LENGTH);
			if(mos==null||0>=mos.length){
				System.out.println("Ŀǰûж");
				try {
					Thread.sleep(500);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				continue;
			}
			String res;
			String extCode = "55" ;
			String cpSrvId="cpҵϵԽԱȡ";
			for(GsmpDeliver msg:mos){
				StringBuilder buf = new StringBuilder("\nյж:\n") ;
				buf.append( "жֻ:").append( msg.getSrcTermId() ).append("\n") ;
				buf.append( "жų:").append( msg.getDestTermId() ).append("\n") ;
				buf.append( "ж  :").append( msg.getMsgCont() ).append("\n") ;
				buf.append( "жű  :").append( msg.getMsgId() ).append("\n") ;
				buf.append( "жCPҵ:").append( msg.getServiceId() ).append("\n") ;
				buf.append( "ֻ㲥Ȩ(Ϊnull):").append( msg.getLinkId() ).append("\n") ;
				
				System.out.println( buf.toString() ) ;
				try {
					res = proxy.submitMTSMS(msg.getSrcTermId(), "лʹ˵㲥ϵͳлл",cpSrvId,extCode);
					Thread.sleep(5000);
				} catch (SocketTimeoutException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (GSMPIllegalStateException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (GSMPNetException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ConnectionAlreadyCloseedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
			}
		}
	}
}
/**
 * Ǵжẉ̂߳ǻȡreportǴӶȡģGSMP Server ͨŻȡreport<br/>
 * ԶƣԴ˴ҪǷGSMP Server
 */
class ReportThread extends Thread{
	private GSMPProxy proxy;
	public ReportThread(GSMPProxy proxy){
		this.proxy=proxy;
	}
	public void run(){
		System.out.println("ReportThread thread start.....");
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		while(true){
			//ԲжǷӣϵͳڲ
//			if(!proxy.isConnected()){
//				String ip="ipַϵԽԱȡ";
//				int port=6685;
//				String user="<cpcorpidϵͳϵԽԱȡ>";
//				String passwd="<cppasswdϵͳϵԽԱȡ>";
//				try {
//					proxy.connect(ip, port, user, passwd, 30, "./wisent_log.properties");
//				} catch (ConfigFileNotFoundException e1) {
//					// TODO Auto-generated catch block
//					e1.printStackTrace();
//					return ;
//				} catch (IllegalArgumentException e1) {
//					// TODO Auto-generated catch block
//					e1.printStackTrace();
//					return ;
//				} catch (ConnectionAreadyConnectedException e1) {
//					// TODO Auto-generated catch block
//					e1.printStackTrace();
//				}
//			}
			GsmpReport[] reports=proxy.getReports(GsmpClientTest.MAX_RECIEVE_LENGTH);
			if(null==reports||0>=reports.length){
				System.out.println("Ŀǰûյreport");
				try {
					Thread.sleep(500);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				continue;
			}
			for(GsmpReport msg:reports){
				StringBuilder buf = new StringBuilder("\nյ״̬:\n") ;
				buf.append( "״̬Ӧжű:" ).append( msg.getSubmitMsgId() ).append("\n") ;
				buf.append( "Ӧжֻ      :" ).append( msg.getDestTermId() ).append("\n") ;
				buf.append( "״̬Ӧж״̬:" ).append( msg.getStat() ).append("\n") ;
				//ֶοΪnullȡڶԽӵӪ
				
				System.out.println( buf.toString() ) ;
			}
		}
	}
}